osgParticle::ParticleSystemUpdater Class Reference

`#include <ParticleSystemUpdater>`

Inheritance diagram for osgParticle::ParticleSystemUpdater:

## Public Member Functions

| ParticleSystemUpdater ()
| ParticleSystemUpdater (const ParticleSystemUpdater &copy, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Node (osgParticle, ParticleSystemUpdater)
virtual bool | addParticleSystem (ParticleSystem *ps)
| Add a particle system to the list.
virtual bool | removeParticleSystem (ParticleSystem *ps)
| Remove a particle system from the list (by pointer).
virtual bool | removeParticleSystem (unsigned int i, unsigned int numParticleSystemsToRemove=1)
| Remove a particle system(s) from the list (by index).
virtual bool | replaceParticleSystem (ParticleSystem *origPS, ParticleSystem *newPS)
| Replace ParticleSystem with another ParticleSystem.
virtual bool | setParticleSystem (unsigned int i, ParticleSystem *ps)
| set a particle system by index.
unsigned int | getNumParticleSystems () const
| Return the number of particle systems on the list.
ParticleSystem * | getParticleSystem (unsigned int i)
| Get a particle system from the list.
const ParticleSystem * | getParticleSystem (unsigned int i) const
| Get a particle system from the list.
bool | containsParticleSystem (const ParticleSystem *ps) const
| return true if ParticleSystem is contained within ParticlsSystemUpdater.
unsigned int | getParticleSystemIndex (const ParticleSystem *ps) const
| get index number of ParticleSystem.
virtual void | traverse (osg::NodeVisitor &nv)
virtual osg::BoundingSphere | computeBound () const
Public Member Functions inherited from osg::Node
| Node ()
| Node (const Node &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const
virtual Object * | clone (const CopyOp &copyop) const
virtual bool | isSameKindAs (const Object *obj) const
virtual const char * | libraryName () const
virtual const char * | className () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual Geometry * | asGeometry ()
virtual const Geometry * | asGeometry () const
virtual Group * | asGroup ()
virtual const Group * | asGroup () const
virtual Transform * | asTransform ()
virtual const Transform * | asTransform () const
virtual Switch * | asSwitch ()
virtual const Switch * | asSwitch () const
virtual Geode * | asGeode ()
virtual const Geode * | asGeode () const
virtual osgTerrain::Terrain * | asTerrain ()
virtual const osgTerrain::Terrain * | asTerrain () const
virtual void | accept (NodeVisitor &nv)
virtual void | ascend (NodeVisitor &nv)
const ParentList & | getParents () const
ParentList | getParents ()
Group * | getParent (unsigned int i)
const Group * | getParent (unsigned int i) const
unsigned int | getNumParents () const
NodePathList | getParentalNodePaths (osg::Node *haltTraversalAtNode=0) const
MatrixList | getWorldMatrices (const osg::Node *haltTraversalAtNode=0) const
void | setUpdateCallback (Callback *nc)
template<class T>
void | setUpdateCallback (const ref_ptr< T > &nc)
Callback * | getUpdateCallback ()
const Callback * | getUpdateCallback () const
void | addUpdateCallback (Callback *nc)
template<class T>
void | addUpdateCallback (const ref_ptr< T > &nc)
void | removeUpdateCallback (Callback *nc)
template<class T>
void | removeUpdateCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringUpdateTraversal () const
void | setEventCallback (Callback *nc)
template<class T>
void | setEventCallback (const ref_ptr< T > &nc)
Callback * | getEventCallback ()
const Callback * | getEventCallback () const
void | addEventCallback (Callback *nc)
template<class T>
void | addEventCallback (const ref_ptr< T > &nc)
void | removeEventCallback (Callback *nc)
template<class T>
void | removeEventCallback (const ref_ptr< T > &nc)
unsigned int | getNumChildrenRequiringEventTraversal () const
void | setCullCallback (Callback *nc)
template<class T>
void | setCullCallback (const ref_ptr< T > &nc)
Callback * | getCullCallback ()
const Callback * | getCullCallback () const
void | addCullCallback (Callback *nc)
template<class T>
void | addCullCallback (const ref_ptr< T > &nc)
void | removeCullCallback (Callback *nc)
template<class T>
void | removeCullCallback (const ref_ptr< T > &nc)
void | setCullingActive (bool active)
bool | getCullingActive () const
unsigned int | getNumChildrenWithCullingDisabled () const
bool | isCullingActive () const
unsigned int | getNumChildrenWithOccluderNodes () const
bool | containsOccluderNodes () const
void | setNodeMask (NodeMask nm)
NodeMask | getNodeMask () const
void | setStateSet (osg::StateSet *stateset)
template<class T>
void | setStateSet (const osg::ref_ptr< T > &stateset)
osg::StateSet * | getOrCreateStateSet ()
osg::StateSet * | getStateSet ()
const osg::StateSet * | getStateSet () const
void | setDescriptions (const DescriptionList &descriptions)
DescriptionList & | getDescriptions ()
const DescriptionList & | getDescriptions () const
const std::string & | getDescription (unsigned int i) const
std::string & | getDescription (unsigned int i)
unsigned int | getNumDescriptions () const
void | addDescription (const std::string &desc)
void | setInitialBound (const osg::BoundingSphere &bsphere)
const BoundingSphere & | getInitialBound () const
void | dirtyBound ()
const BoundingSphere & | getBound () const
void | setComputeBoundingSphereCallback (ComputeBoundingSphereCallback *callback)
template<class T>
void | setComputeBoundingSphereCallback (const ref_ptr< T > &callback)
ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback ()
const ComputeBoundingSphereCallback * | getComputeBoundingSphereCallback () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
std::string | getCompoundClassName () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~ParticleSystemUpdater ()
ParticleSystemUpdater & | operator= (const ParticleSystemUpdater &)
Protected Member Functions inherited from osg::Node
virtual | ~Node ()
void | addParent (osg::Group *parent)
void | removeParent (osg::Group *parent)
void | setNumChildrenRequiringUpdateTraversal (unsigned int num)
void | setNumChildrenRequiringEventTraversal (unsigned int num)
void | setNumChildrenWithCullingDisabled (unsigned int num)
void | setNumChildrenWithOccluderNodes (unsigned int num)
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Additional Inherited Members

Public Types inherited from osg::Node
typedef std::vector< Group * > | ParentList
typedef unsigned int | NodeMask
typedef std::vector< std::string > | DescriptionList
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()
Protected Attributes inherited from osg::Node
BoundingSphere | _initialBound
ref_ptr< ComputeBoundingSphereCallback > | _computeBoundCallback
BoundingSphere | _boundingSphere
bool | _boundingSphereComputed
ParentList | _parents
ref_ptr< Callback > | _updateCallback
unsigned int | _numChildrenRequiringUpdateTraversal
ref_ptr< Callback > | _eventCallback
unsigned int | _numChildrenRequiringEventTraversal
ref_ptr< Callback > | _cullCallback
bool | _cullingActive
unsigned int | _numChildrenWithCullingDisabled
unsigned int | _numChildrenWithOccluderNodes
NodeMask | _nodeMask
ref_ptr< StateSet > | _stateset
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Detailed Description

A useful node class for updating particle systems automatically. When a ParticleSystemUpdater is traversed by a cull visitor, it calls the update() method on the specified particle systems. You should place this updater AFTER other nodes like emitters and programs.

## Constructor & Destructor Documentation

## ParticleSystemUpdater() [1/2]

osgParticle::ParticleSystemUpdater::ParticleSystemUpdater | ( |  | ) |

Referenced by META_Node(), operator=(), and ParticleSystemUpdater().

## ParticleSystemUpdater() [2/2]

osgParticle::ParticleSystemUpdater::ParticleSystemUpdater | ( | const ParticleSystemUpdater & | copy,
|  | const osg::CopyOp & | copyop = osg::CopyOp::SHALLOW_COPY )

References ParticleSystemUpdater(), and osg::CopyOp::SHALLOW_COPY.

## ~ParticleSystemUpdater()

virtual osgParticle::ParticleSystemUpdater::~ParticleSystemUpdater | ( |  | ) |

inline protected virtual

## Member Function Documentation

## addParticleSystem()

virtual bool osgParticle::ParticleSystemUpdater::addParticleSystem | ( | ParticleSystem * | ps | ) |

virtual

Add a particle system to the list.

## computeBound()

virtual osg::BoundingSphere osgParticle::ParticleSystemUpdater::computeBound | ( |  | ) | const

virtual

Compute the bounding sphere around Node's geometry or children. This method is automatically called by getBound() when the bounding sphere has been marked dirty via dirtyBound().

Reimplemented from osg::Node.

## containsParticleSystem()

bool osgParticle::ParticleSystemUpdater::containsParticleSystem | ( | const ParticleSystem * | ps | ) | const

inline

return true if ParticleSystem is contained within ParticlsSystemUpdater.

Referenced by setParticleSystem().

## getNumParticleSystems()

unsigned int osgParticle::ParticleSystemUpdater::getNumParticleSystems | ( |  | ) | const

inline

Return the number of particle systems on the list.

Referenced by setParticleSystem().

## getParticleSystem() [1/2]

ParticleSystem * osgParticle::ParticleSystemUpdater::getParticleSystem | ( | unsigned int | i | ) |

inline

Get a particle system from the list.

Referenced by setParticleSystem().

## getParticleSystem() [2/2]

const ParticleSystem * osgParticle::ParticleSystemUpdater::getParticleSystem | ( | unsigned int | i | ) | const

inline

Get a particle system from the list.

## getParticleSystemIndex()

unsigned int osgParticle::ParticleSystemUpdater::getParticleSystemIndex | ( | const ParticleSystem * | ps | ) | const

inline

get index number of ParticleSystem.

Referenced by setParticleSystem().

## META_Node()

osgParticle::ParticleSystemUpdater::META_Node | ( | osgParticle | ,
|  | ParticleSystemUpdater | )

References ParticleSystemUpdater().

## operator=()

ParticleSystemUpdater & osgParticle::ParticleSystemUpdater::operator= | ( | const ParticleSystemUpdater & |  | ) |

inline protected

References ParticleSystemUpdater().

## removeParticleSystem() [1/2]

virtual bool osgParticle::ParticleSystemUpdater::removeParticleSystem | ( | ParticleSystem * | ps | ) |

virtual

Remove a particle system from the list (by pointer).

## removeParticleSystem() [2/2]

virtual bool osgParticle::ParticleSystemUpdater::removeParticleSystem | ( | unsigned int | i,
|  | unsigned int | numParticleSystemsToRemove = 1 )

virtual

Remove a particle system(s) from the list (by index).

## replaceParticleSystem()

virtual bool osgParticle::ParticleSystemUpdater::replaceParticleSystem | ( | ParticleSystem * | origPS,
|  | ParticleSystem * | newPS )

virtual

Replace ParticleSystem with another ParticleSystem.

## setParticleSystem()

virtual bool osgParticle::ParticleSystemUpdater::setParticleSystem | ( | unsigned int | i,
|  | ParticleSystem * | ps )

virtual

set a particle system by index.

References containsParticleSystem(), getNumParticleSystems(), getParticleSystem(), and getParticleSystemIndex().

## traverse()

virtual void osgParticle::ParticleSystemUpdater::traverse | ( | osg::NodeVisitor & |  | ) |

virtual

Traverse downwards : calls children's accept method with NodeVisitor.

Reimplemented from osg::Node.

The documentation for this class was generated from the following file:

- ParticleSystemUpdater